from setuptools import setup, find_packages

setup(
    name='mix_eval',
    version='0.0',
    author='MixEval team',
    packages=find_packages(),
    install_requires=[
        'transformers @ git+https://github.com/huggingface/transformers.git@main#egg=transformers',
        'tiktoken>=0.6.0',
        'fschat==0.2.36',
        'pandas',
        'scikit-learn',
        'hf_transfer',
        'SentencePiece',
        'accelerate',
        'openai',
        'httpx',
        'nltk',
        'numpy',
        'tqdm',
        'protobuf',
        'python-dotenv',
        'jetmoe @ git+https://github.com/myshell-ai/JetMoE.git',
        'ai2-olmo',
        'anthropic',
        'mistralai',
        'google-generativeai',
        'google-cloud-aiplatform',
        'reka-api'
    ],
    package_data={
    },
    entry_points={
    },
    license='License :: OSI Approved :: MIT License',
    description='A state-of-the-art benchmark and eval suite for Large Language Models.',
    long_description=open('README.md').read(),
    long_description_content_type='text/markdown',
)

